require 'studio_game/clumsy_player'

module StudioGame
  describe ClumsyPlayer do
    before do
      $stdout = StringIO.new
      @boost_factor = 2
      @player = ClumsyPlayer.new("Johan", 100, @boost_factor)
    end

    it "has a boost factor" do
      expect(@player.boost_factor).to eq(2)
    end

    it "gets boost factor number of w00ts when wooted" do
      @player.w00t
      expect(@player.health).to eq(100 + 15 * @boost_factor)
    end

    it "half the point of the treasure found by the clumsy player" do
      hammer = Treasure.new(:hammer, 50)
      @player.found_treasure(hammer)
      @player.found_treasure(hammer)
      @player.found_treasure(hammer)

      expect(@player.points).to eq(75)

      sword = Treasure.new(:sword, 200)
      @player.found_treasure(sword)
      @player.found_treasure(sword)

      expect(@player.points).to eq(275)

      yielded = []

      @player.each_found_treasure do |treasure|
        yielded << treasure
      end

      expect(yielded).to eq([Treasure.new(:hammer, 75), Treasure.new(:sword, 200)])

    end
  end

end