require 'studio_game/treasure_trove'

module StudioGame
  
  describe Treasure do 
    before do 
      @initial_name = "Excalibur"
      @initial_point = 1000
      @treasure = Treasure.new(@initial_name, @initial_point)
    end

    it "has a name attribute" do
      expect(@treasure.name).to eq(@initial_name)
    end

    it "has a point attribute" do
      expect(@treasure.point).to eq(@initial_point)
    end
  end

  describe TreasureTrove do

    it "TreasureTrove has a constant treasures with the size of 6" do 
      expect(TreasureTrove::TREASURES.size).to eq(6)
    end

    it "excalibur inside treasures worth 1000 points" do
      expect(TreasureTrove::TREASURES[0].point).to eq(1000)
    end

    it "ragnarok inside treasure worth 900 points" do
      expect(TreasureTrove::TREASURES[1].point).to eq(900)
    end

    it "omniblade inside treasure worth 5000 points" do
      expect(TreasureTrove::TREASURES[2].point).to eq(5000)
    end

    it "zeldricht inside treasure worth 500 points" do
      expect(TreasureTrove::TREASURES[3].point).to eq(500)
    end

    it "xenoblade inside treasure worh 10000 points" do
      expect(TreasureTrove::TREASURES[4].point).to eq(10000)
    end

    it "falkhir inside treasure worth 800 points" do
      expect(TreasureTrove::TREASURES[5].point).to eq(800)
    end

    it "successfuly gives a random treasure inside the treasures" do
      treasure = TreasureTrove.random
      expect(TreasureTrove::TREASURES).to include(treasure)
    end


  end
end